package PipSqueek::Plugin::DateTime;
use base qw(PipSqueek::Plugin);

use POSIX qw(strftime);

sub plugin_initialize
{
	my $self = shift;

	$self->plugin_handlers([
		'multi_date',
		'multi_time',
		'multi_stime',
	]);
}


sub multi_date
{
	(shift)->respond( shift, strftime("%A %B the %d, %Y", gmtime(time)) );
}


sub multi_time
{
	(shift)->respond( shift, strftime("%T GMT", gmtime(time)) );
}


sub multi_stime
{
	(shift)->respond( shift, time() );
}


1;


__END__
